package tools.descartes.dql.connector.kieker.structures.interfaces;

import java.util.Map.Entry;

import tools.descartes.dql.connector.kieker.structures.classes.ClassMap;
import tools.descartes.dql.connector.kieker.structures.classes.ClassMapKey;
import tools.descartes.dql.connector.kieker.structures.classes.ClassMapValue;

public class InterfaceMapKey  {

	private final String interfaceID;
	private final long classID;
	private final String requestID;
	
	public InterfaceMapKey(String interfaceID, long componentID, String requestID){
		this.interfaceID = interfaceID;
		this.classID = componentID;
		this.requestID = requestID;
	}


	public String getInterfaceID() {
		return interfaceID;
	}


	public long getClassID() {
		return classID;
	}
	
	public String getRequestID() {
		return requestID;
	}

	public String getClassInfo(){
		for (Entry<ClassMapKey, ClassMapValue> item : ClassMap.getInstance().entrySet()) {
			if (item.getValue().getID()==classID) {
				return item.getKey().getClassID();
			}
		}
		return "";
	}


	@Override
	public String toString(){
		return String.format("@[%s] %s \t by request \"%s\"", classID, interfaceID,requestID);
	}


	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ (int) (classID ^ (classID >>> 32));
		result = prime * result
				+ ((interfaceID == null) ? 0 : interfaceID.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		InterfaceMapKey other = (InterfaceMapKey) obj;
		if (classID != other.classID)
			return false;
		if (interfaceID == null) {
			if (other.interfaceID != null)
				return false;
		} else if (!interfaceID.equals(other.interfaceID))
			return false;
		return true;
	}

}
